#!/usr/local/bin/perl -wT
use strict;
use CGI;
use DBI;
use FileHandle;
use HTML::Template;
use WebDP::Logger;

use vars qw($ImagePath);
$ImagePath = '/path/to/image.gif';

my $query = CGI->new;
do_task($query);

sub do_task {
    my $query = shift;
    my $check = check_id($query);
    if ($check) {
        WebDP::Logger->logit(debug => 'check ok. print out image.');
        print $query->header('image/gif');        #
        my $handle = FileHandle->new($ImagePath); #
        while (<$handle>) { print; }              # #2
        $handle->close;                           #
    }
    else {
        WebDP::Logger->logit(info => "check failed");
        error_out($query);        # #3
    }
}

sub check_id {
    my $query = shift;
    my $id = $query->param('id') or do {
        WebDP::Logger->logit(info => 'id not found');
        return;
    };

    my $dbh = DBI->connect('dbi:mysql:webdpdownload', 'user', 'pass', { RaiseError => 1 }) or do {
        WebDP::Logger->logit(alert => "db connection failed: $DBI::errstr");
        die $DBI::errstr;
    };

    WebDP::Logger->logit(debug => "find id = $id");
    my $sth = $dbh->prepare(<<'SQL'); # #1
SELECT COUNT(*) FROM download WHERE url_id = ? AND expires >= NOW()
SQL
    ;

    my $count;
    eval {
        $sth->execute($id);
        my $data = $sth->fetchrow_arrayref;
        $count = $data->[0];
        $sth->finish;
    };
    if ($@ or $count == 0) {
        WebDP::Logger->logit(info => "entry for $id not found.");
        return;
    }
    $dbh->disconnect;
    return 1;
}

sub error_out {
    my $query = shift;
    print $query->header('text/html'), <<HTML;
<HTML><BODY>
ERROR!
</BODY></HTML>
HTML
    ;
}