#!/usr/local/bin/perl -w
use strict;
use Log::Dispatch;
use Log::Dispatch::File;
use Log::Dispatch::Email::MIMELite;
use Sys::Hostname;

my $dispatcher = Log::Dispatch->new;

$dispatcher->add(
    Log::Dispatch::File->new(
        name      => 'applog',
        min_level => 'debug',
        filename  => '/tmp/app.log',
        mode      => 'append',
        callbacks => sub {
            my %p = @_;
            return sprintf "[%s] %s\n", scalar localtime, $p{message};
        },                        # #1
    ),
);

$dispatcher->add(
    Log::Dispatch::Email::MIMELite->new(
        name      => 'email',
        min_level => 'emergency',
        to        => 'sample@exmple.com',
        subject   => '[webdp] EMERGENCY',
        callbacks => sub {
            my %p = @_;
            my $hostname = hostname;
            return <<MAIL;
Something *BAD* happend on $hostname.

$p{message}
MAIL
    ;
        },                        # #2
    ),
);

$dispatcher->debug('Program started');
$dispatcher->emergency('Transation failed!');